PRINT N'Modificando [dbo].[DeleteUtterance]...';


GO
ALTER PROCEDURE [dbo].[DeleteUtterance] (
	@VCC			VARCHAR(50) = NULL,
	@AppId			VARCHAR(50) = NULL,
	@IntentId		VARCHAR(50) = NULL,
	@Id				VARCHAR(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON
    -- DECLARE @ENGINE VARCHAR(15)  = (SELECT [CognitiveEngine] FROM [dbo].[VCC] (NOLOCK) WHERE [VCC] = @VCC)
	-- DECLARE @ID     VARCHAR(50) = @UtteranceId
	-- DECLARE @TempId VARCHAR(50) = NULL
	
	DELETE [Utterance] 
		WHERE [VCC] = @VCC
			AND [AppId] = @AppId
			AND [IntentId] = @IntentId
			AND [Id] = @Id
	
	DELETE [UtteranceEntity] 
		WHERE [VCC] = @VCC
			AND [UtteranceId] = @Id
			
			
	DELETE FROM [dbo].[Underlined] WHERE [UtteranceId] = @Id

    SELECT 1 AS 'result'
    
    SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetUtterance]...';


GO
-- [dbo].[GetUtterancesByIntentId] 'allegro', '45799dd8-17e7-49a1-9bd8-cb74f00a788c'
ALTER PROCEDURE [dbo].[GetUtterance]
(
	@VCC			VARCHAR(50),
	@AppId			VARCHAR(50),
	@IntentName		VARCHAR(50),
	@Text			VARCHAR(500)
)
AS
BEGIN
	SET NOCOUNT ON

	DECLARE @INTENT_ID VARCHAR(50) = NULL
	SELECT @INTENT_ID = [IntentId]
		FROM [dbo].[Intent] (NOLOCK) 
		WHERE [VCC] = @VCC
			AND [AppId] = @AppId
			AND [Name] = @IntentName
  
    -- BUSCAMOS LOS UTTERANCES SEGUN LOS PARAMETROS RECIBIDOS
	SELECT U.[VCC]								'vcc',
			U.[AppId]							'appId',
			U.[IntentId]						'intentId',
			I.[Name]							'intentName',
			U.[Id]								'id',
			U.[Text]							'text',
			U.[CreatedDate]						'createdDate',
			U.[CreatedByUserId]					'createdByUserId',
			U.[LastModifiedDate]				'lastModifiedDate',
			U.[LastModifiedByUserId]			'lastModifiedByUserId'
		FROM [dbo].[Utterance] U (NOLOCK)
		INNER JOIN [dbo].[Intent] I (NOLOCK) 
			ON I.[VCC] = U.[VCC]
				AND I.[IntentId] = U.[IntentId]
		WHERE U.[VCC] = @VCC
			AND U.[AppId] = @AppId
			AND U.[IntentId] = @INTENT_ID
			AND U.[Text] = @Text

	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[SaveUtterance]...';


GO
ALTER PROCEDURE [dbo].[SaveUtterance]
(
	@VCC						VARCHAR(50),
	@AppId						VARCHAR(50),
	@IntentName					VARCHAR(50),
	@Id							VARCHAR(50),
	@Text						VARCHAR(500),
	@UserId			            VARCHAR(50)
)
AS
BEGIN
	SET NOCOUNT ON
	
	DECLARE @INTENT_ID VARCHAR(50) = NULL
	SELECT @INTENT_ID = [IntentId]
		FROM [dbo].[Intent] (NOLOCK) 
		WHERE [VCC] = @VCC
			AND [AppId] = @AppId
			AND [Name] = @IntentName
	
  
    IF(NOT EXISTS (
		SELECT [Id] 
			FROM [dbo].[Utterance] (NOLOCK) 
			WHERE VCC = @VCC 
				AND [AppId] = @AppId
				AND [IntentId] = @INTENT_ID
				AND [Id] = @Id 
	)) 
	BEGIN
	       
		INSERT INTO [dbo].[Utterance] (
				[VCC],
				[AppId],
				[IntentId],
				[Id],
				[Text],
				[CreatedByUserId],
				[Status],
				[StatusCode]
			)
			VALUES(
				@VCC,
				@AppId,
				@INTENT_ID,
				@Id,
				LOWER(@Text),
				@UserId,
				1,
				'AVAILABLE'
			)
	END

    SELECT [Id] AS 'utteranceId'
		FROM [dbo].[Utterance] (NOLOCK)
	    WHERE [VCC] = @VCC
			AND [AppId] = @AppId
			AND [IntentId] = @INTENT_ID
			AND [Id] = @Id

	SET NOCOUNT OFF
END
GO
PRINT N'Actualización completada.';


GO
